import 'package:get/get.dart';
import 'package:mypoint_flutter_app/networking/restful_api_request.dart';
import '../../../base/restful_api_viewmodel.dart';
import '../models/product_model.dart';
import '../models/product_store_model.dart';

class VoucherDetailViewModel extends RestfulApiViewModel {
  final int productId;
  VoucherDetailViewModel({required this.productId});
  var stores =  RxList<ProductStoreModel>();
  var product = Rxn<ProductModel>();
  var isLoading = false.obs;

  @override
  void onInit() {
    super.onInit();
    _getProductDetail();
    _getProductStores();
  }

  Future<void> _getProductDetail() async {
    if (isLoading.value) return;
    try {
      isLoading.value = true;
      final response = await client.getProduct(productId);
      product.value = response.data;
    } catch (error) {
      print("Error fetching product detail: $error");
    } finally {
      isLoading.value = false;
    }
  }

  Future<void> _getProductStores() async {
    try {
      final response = await client.getProductStores(productId);
      stores.value = response.data ?? [];
    } catch (error) {
      print("Error fetching product detail: $error");
    } finally {
    }
  }
}
